module GraphicsBrush
	( Brush
	, create, delete, select
	-- , blackBrush, whiteBrush
	) where

import GraphicsTypes
import qualified Win32

----------------------------------------------------------------
-- The interface
----------------------------------------------------------------

newtype Brush = MkBrush Win32.HBRUSH

create :: RGB   -> IO Brush
delete :: Brush -> IO ()
select :: Brush -> Draw Brush

----------------------------------------------------------------
-- The implementation
----------------------------------------------------------------

create (RGB r g b) = Win32.createSolidBrush (Win32.rgb r g b) >>= return . MkBrush
delete (MkBrush b) = Win32.deleteBrush b
select (MkBrush b) = mkDraw (\hdc -> do
  b' <- Win32.selectBrush hdc b
  return (MkBrush b'))

----------------------------------------------------------------
-- 
-- -- special cases - these should _never_ be deleted
-- blackBrush :: IO Brush
-- whiteBrush :: IO Brush
-- 
-- blackBrush = Win32.getStockBrush Win32.bLACK_BRUSH >>= return . MkBrush
-- whiteBrush = Win32.getStockBrush Win32.wHITE_BRUSH >>= return . MkBrush
-- 
----------------------------------------------------------------
